package fortedit;

import java.awt.event.ActionEvent;

import javax.swing.*;

import fortedit.carte.Element;
import fortedit.editeur.Editeur;

public class CarteEditeurIntervertirFenetre extends AbstractAction{
	private static final long serialVersionUID = 1L;
	private Editeur carteEditeur;
	private JDialog dialogueFenetre;
	private JPanel dialogue;
	private JComboBox<Element> choix1,choix2;
	
	public CarteEditeurIntervertirFenetre(Editeur carteEditeur) {
		this.carteEditeur=carteEditeur;
		
		dialogueFenetre = new JDialog();
		dialogueFenetre.setTitle("Intervertir");
		
		dialogue = new JPanel();
		choix1 = new JComboBox<Element>(Element.values());
		dialogue.add(getChoix1());
		dialogue.add(new JLabel("et"));
		choix2 = new JComboBox<Element>(Element.values());
		dialogue.add(getChoix2());
		
		JButton bouton = new JButton(new CarteEditeurIntervertirAction(this.carteEditeur, this));
		bouton.setText("Intervertir");
		dialogue.add(bouton);
		
		dialogueFenetre.add(dialogue);
		dialogueFenetre.pack();
		dialogueFenetre.setResizable(false);
	}

	public void actionPerformed(ActionEvent arg0) {
		dialogueFenetre.setVisible(true);
		dialogueFenetre.setLocationRelativeTo(carteEditeur);
		dialogueFenetre.setAlwaysOnTop(true);
	}

	public JComboBox<Element> getChoix1() {
		return choix1;
	}

	public JComboBox<Element> getChoix2() {
		return choix2;
	}
}

class CarteEditeurIntervertirAction extends AbstractAction{
	private static final long serialVersionUID = 1L;
    private Editeur carteEditeur;
    private CarteEditeurIntervertirFenetre dialogueFenetre;

    public CarteEditeurIntervertirAction(Editeur carteEditeur, CarteEditeurIntervertirFenetre dialogueFenetre) {
        this.carteEditeur = carteEditeur;
        this.dialogueFenetre = dialogueFenetre;
    }

    public void actionPerformed(ActionEvent arg0) {
        carteEditeur.getCartes().Ajouter(carteEditeur.getCartes().getCurrent());
        for (int i = 0; i < 200; i++)
            for (int j = 0; j < 100; j++)
                if (carteEditeur.getCartes().getPrevious().getCases()[i][j] == dialogueFenetre.getChoix1().getSelectedItem()) {
                    carteEditeur.getCartes().getCurrent().getCases()[i][j] = (Element) dialogueFenetre.getChoix2().getSelectedItem();
                } else if (carteEditeur.getCartes().getPrevious().getCases()[i][j] == dialogueFenetre.getChoix2().getSelectedItem()) {
                    carteEditeur.getCartes().getCurrent().getCases()[i][j] = (Element) dialogueFenetre.getChoix1().getSelectedItem();
                }
        carteEditeur.getImage().redessinner();
        carteEditeur.getImage().modif = true;
    }
}
