package fortedit;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import fortedit.editeur.Editeur;

public class CarteEditeurSymetriserFenetre extends AbstractAction{
	private static final long serialVersionUID = 1L;
    private Editeur editeur;
    private JDialog dialogueFenetre;
    private JPanel dialogue;
    private JComboBox<String> choix;

    public CarteEditeurSymetriserFenetre(Editeur editeur) {
        this.editeur = editeur;

        dialogueFenetre = new JDialog();
        dialogueFenetre.setTitle("Symtriser");

        dialogue = new JPanel();
        dialogue.add(new JLabel("Garder la partie"));
        String[] elements = new String[]{"gauche", "droite"};
        choix = new JComboBox<String>(elements);
        dialogue.add(getChoix());

        JButton bouton= new JButton(new CarteEditeurSymetriserAction(editeur, this));
        dialogue.add(bouton);

        dialogueFenetre.add(dialogue);
        dialogueFenetre.pack();
        dialogueFenetre.setResizable(false);
    }

    public void actionPerformed(ActionEvent arg0) {
        dialogueFenetre.setVisible(true);
        dialogueFenetre.setLocationRelativeTo(editeur);
        dialogueFenetre.setAlwaysOnTop(true);
    }

	public JComboBox<String> getChoix() {
		return choix;
	}
}

class CarteEditeurSymetriserAction extends AbstractAction{
	private static final long serialVersionUID = 1L;
    private Editeur editeur;
    private CarteEditeurSymetriserFenetre dialogueFenetre;

    public CarteEditeurSymetriserAction(Editeur editeur, CarteEditeurSymetriserFenetre dialogueFenetre) {
        super("Symtriser");

        this.editeur = editeur;
        this.dialogueFenetre = dialogueFenetre;
    }

    public void actionPerformed(ActionEvent arg0) {
    	editeur.getCartes().Ajouter(editeur.getCartes().getCurrent());
        if(dialogueFenetre.getChoix().getSelectedIndex() == 0) {
            for(int i = 100; i < 200; i++)
            	editeur.getCartes().getCurrent().getCases()[i] = editeur.getCartes().getCurrent().getCases()[199 - i];
        } else {
            for(int i = 0; i < 100; i++)
            	editeur.getCartes().getCurrent().getCases()[i] = editeur.getCartes().getCurrent().getCases()[199 - i];
        }
        editeur.getImage().redessinner();
        editeur.getImage().modif = true;
    }
}
