package fortedit;

import java.awt.datatransfer.*;
import java.io.File;

import javax.swing.*;

import fortedit.editeur.Editeur;

public class CarteEditeurTransferHandler extends TransferHandler {
	private static final long serialVersionUID = 1L;
	private Fenetre fenetre;
	 
    public CarteEditeurTransferHandler(Fenetre fenetre) {
		this.fenetre = fenetre;
	}
    
    private void Charger(String fichierAdresse) {
    	File fichier = new File(fichierAdresse);
    	Editeur editeur = fenetre.getEditeur();
    	editeur.setFichier(fichier);
		editeur.setRepertoire(fichier.getParentFile());
		fenetre.setTitle(fichier.getName() + " - diteur de cartes pour forteresse");
		editeur.setEtatFichier(fichier.getAbsolutePath());
		editeur.getCartes().Init();
        editeur.getCartes().getCurrent().Load(fichier);
		fenetre.getMenuEditionMondesBouton().get(fenetre.getEditeur().getCartes().getCurrent().getMonde()).setSelected(true);
		editeur.getImage().redessinner();
		editeur.getImage().modif=false;
    }

	public boolean canImport(JComponent cp, DataFlavor[] df) {
      for (int i = 0; i < df.length; i++) {
        if (df[i].equals(DataFlavor.javaFileListFlavor)) {
          return true;
        }
        if (df[i].equals(DataFlavor.stringFlavor)) {
          return true;
        }
      }
      return false;
    }
 
    private boolean hasFileFlavor(DataFlavor[] df) {
      boolean result = false;
      for (DataFlavor flavor : df) {
        result = DataFlavor.javaFileListFlavor.equals(flavor);
        if (result) {
          break;
        }
      }
      return result;
    }
 
    private boolean hasStringFlavor(DataFlavor[] df) {
      boolean result = false;
      for (DataFlavor flavor : df) {
        result = DataFlavor.stringFlavor.equals(flavor);
        if (result) {
          break;
        }
      }
      return result;
    }

    public boolean importData(JComponent cp, Transferable tr) {
      if (this.hasFileFlavor(tr.getTransferDataFlavors())) {
        try {
          Charger(tr.getTransferData(DataFlavor.javaFileListFlavor).toString().substring(1, tr.getTransferData(DataFlavor.javaFileListFlavor).toString().length()-1));
          return true;
        }
        catch (Exception e) {
          e.printStackTrace();
        }
        return false;
      }
      if (this.hasStringFlavor(tr.getTransferDataFlavors())) {
        try {
          String myData = (String) (tr.getTransferData(DataFlavor.stringFlavor));
          Charger(myData.substring(5, myData.length()-2));
        }
        catch (Exception e) {
          e.printStackTrace();
        }
      }
      return false;
    }
  }