package fortedit;

import java.awt.Color;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.KeyStroke;

import fortedit.carte.Element;
import fortedit.editeur.Editeur;

public class CarteEditeursetCouleurBouton extends JButton {
	private static final long serialVersionUID = 1L;
	
    public CarteEditeursetCouleurBouton(Editeur editeur, Element element) {
        setAction(new CarteEditeursetCouleurAction(editeur, element));
        
        String OS = System.getProperty("os.name").toLowerCase();
        if(!OS.startsWith("mac")) {
            this.setBackground(element.getCouleur());
            this.setForeground(Color.WHITE);
        }
        
        setText(element.getNom());

        setPreferredSize(getPreferredSize());

        editeur.getInputMap().put(KeyStroke.getKeyStroke(element.getTouche()), element.getTouche());
        editeur.getActionMap().put(element.getTouche(), this.getAction());
        this.setToolTipText(element.getTouche());

        setMnemonic(element.getMnemonic());
    }
}

class CarteEditeursetCouleurAction extends AbstractAction{
	private static final long serialVersionUID = 1L;
    private Editeur editeur;
    private Element element;
    
    public CarteEditeursetCouleurAction(Editeur editeur, Element element) {
        this.editeur = editeur;
        this.element = element;
    }

    public void actionPerformed(ActionEvent arg0) {
    	editeur.getImage().setElement(element);
    }
}
