package fortedit;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.*;

public class CarteSaveSous extends AbstractAction{
	private static final long serialVersionUID = 1L;
	private Fenetre fenetre;
    private int n;

    public CarteSaveSous(Fenetre fenetre, String nom) {
        super(nom);

        this.fenetre=fenetre;
    }

    public void actionPerformed(ActionEvent arg0) {
        JFileChooser adresse=new JFileChooser();
        adresse.setFileFilter(new Filtre("Carte", 20002, 20003));
        adresse.setSelectedFile(fenetre.getEditeur().getFichier());
        adresse.setCurrentDirectory(fenetre.getEditeur().getRepertoire());
        if(adresse.showSaveDialog(null)==JFileChooser.APPROVE_OPTION) {
            if(Filtre.getExtension(adresse.getSelectedFile()).compareTo("txt") != 0)
                adresse.setSelectedFile(new File(adresse.getSelectedFile().getAbsolutePath() + ".txt"));
            
            if(adresse.getSelectedFile().exists())
                n = JOptionPane.showConfirmDialog(null, "Ce fichier existe dj, voulez-vous l'craser ?", "Attention !", JOptionPane.YES_NO_OPTION);
            else
            	n = 0;

            if(n == 0) {
                fenetre.getEditeur().setFichier(adresse.getSelectedFile());
                fenetre.getEditeur().setRepertoire(adresse.getSelectedFile().getParentFile());
                fenetre.setTitle(adresse.getSelectedFile().getName() + " - diteur de cartes pour forteresse");
                fenetre.getEditeur().setEtatFichier(adresse.getSelectedFile().getAbsolutePath());
                fenetre.getEditeur().getCartes().getCurrent().Save(adresse.getSelectedFile());
                fenetre.getEditeur().getImage().modif = false;
            }
        }
    }
}