package fortedit;

import java.io.File;

import javax.swing.filechooser.FileFilter;

public class Filtre extends FileFilter {
	public final int TYPE_POIDS = 0, TYPE_EXTENSION = 1;
    private String nom;
    private int type;
    private String extension;
    private int i, j;

    public Filtre(String nom, String extension) {
        this.nom = nom;
        this.extension = extension;
        type = TYPE_EXTENSION;
    }


    public Filtre(String nom, int i, int j) {
        this.nom = nom;
        this.i = i;
        this.j = j;
        type = TYPE_POIDS;
    }

    public boolean accept(File f) {
        if (f.isDirectory())
            return true;
        
        if(type == TYPE_POIDS) {
            if(f.length() >= i && f.length() <= j)
                return true;
            else
                return false;
        } else if(type == TYPE_EXTENSION) {
            String extension = getExtension(f);
            if (extension != null)
                if (extension.equals(this.extension))
                    return true;
                else
                	return false;
        }
        return false;
    }

    public String getDescription() {
        return nom;
    }
    
    public static String getExtension(File f) {
        String ext = "";
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1)
            ext = s.substring(i+1).toLowerCase();
        
        return ext;
    }
}
