package fortedit.carte;

import java.io.*;

import fortedit.mondes.Monde;

public class Carte implements Cloneable {
    private Monde monde;
    private Element[][] cases = new Element[200][100];

    public Carte() {
        setMonde(Monde.MONDE_7);
        for(int i = 0; i < 200; i++)
            for(int j = 0; j < 100; j++)
            	cases[i][j] = Element.VIDE_C;
    }
	
    public void Load(File file) {
        try {
            if(file!=null) {
                BufferedReader fichier = new BufferedReader(new FileReader(file));
                String ligne = fichier.readLine();
                fichier.close();
                
                if (ligne != null) {
                    String[] parties = ligne.split("-");
                    if (parties.length == 2) {
                        monde = Monde.parse(parties[0]);
                        if (monde == null) {
                        	throw new Exception("Fichier non valide");
                        }
                        
                        char[] casesC = new char[20000];
                        parties[1].getChars(0, 100 * 200, casesC, 0);
                        for (int i = 0; i < 200; i++) {
                            for (int j = 0; j < 100; j++) {
                            	cases[i][j] = Element.parse(casesC[i * 100 + j]);
                                if (cases[i][j] == null) {
                                	throw new Exception("Fichier non valide");
                                }
                            }
                        }
                    } else {
                    	throw new Exception("Fichier non valide");
                    }
                } else {
                	throw new Exception("Fichier non valide");
                }
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Exception e) {
			e.printStackTrace();
		}
    }

    public void Save(File file) {
        try {
            if(file!=null) {
            	String mondeS = monde.getCode();
                char[] casesC = new char[20000];
                for (int i = 0; i < 200; i++) {
                    for (int j = 0; j < 100; j++) {
                    	casesC[i * 100 + j] = cases[i][j].getCode();
                    }
                }
                String casesS = new String(casesC);
                
                String fichierS = mondeS + "-" + casesS;
            	
                BufferedWriter fichier = new BufferedWriter(new FileWriter(file));
                fichier.write(fichierS);
                fichier.close();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

	public Element[][] getCases() {
		return cases;
	}
	
	public void setMonde(Monde monde) {
		this.monde = monde;
	}
	
	public Monde getMonde() {
		return monde;
	}

    @Override
    public Carte clone() {
        Carte carte = new Carte();
        
        carte.monde = monde;
        for (int i = 0; i < 200; i++) {
            carte.cases[i] = cases[i].clone();
        }
        
        return carte;
    }
}
