package fortedit.carte;

import java.awt.Color;

public enum Element {
	VIDE_NC('9', "vide non constructible", new Color(0x828f9f), 'S', "F6"),
	VIDE_C('0', "vide constructible", new Color(0x9e9eaf), 'D', "F7"),
	CARRE_D('1', "carr destructible", new Color(0x1f243d), 'F', "F8"),
	CARRE_I('2', "carr indestructible", Color.BLACK, 'G', "F9"),
	CARRE_NR('8', "carr non reconstructible", Color.MAGENTA, 'H', "F10"),
	FIN('3', "fin de rally", new Color(0xff7f27), 'J', "F11");
	
	private final char code;
	private final String nom;
	private final Color couleur;
	private final char mnemonic;
	private final String touche;
	
	private Element(char code, String nom, Color couleur, char mnemonic, String touche) {
		this.code = code;
		this.nom = nom;
		this.couleur = couleur;
		this.mnemonic = mnemonic;
		this.touche = touche;
	}
	
	public char getCode() {
		return code;
	}
	
	public String getNom() {
		return nom;
	}

	public Color getCouleur() {
		return couleur;
	}

	public char getMnemonic() {
		return mnemonic;
	}
	
	public String getTouche() {
		return touche;
	}

	public static Element parse(char code) {
		for (Element element : Element.values()) {
			if (element.code == code) {
				return element;
			}
		}
		
		return null;
	}
	
	public String toString() {
		return nom;
	}
}