package fortedit.editeur;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.*;

import java.util.Date;
import javax.imageio.ImageIO;
import javax.swing.*;

import fortedit.carte.Element;
import fortedit.mondes.Monde;

public class CarteImage extends JPanel implements MouseListener,MouseMotionListener{
	private static final long serialVersionUID = 1L;
    private int i0, j0, i1, j1;
    private int x, y;
    private long temps;
    public Boolean modif = false, encours = false, libre = false;
    public Boolean grille = false, fond = true, zones = true, mire = true;
    final static int switchGrille = 0, switchFond = 1, switchZones = 2, switchMire = 3, switchZoom = 4, switchLibre = 5;
    private AbstractAction switchGrilleAction, switchFondAction, switchZonesAction, switchMireAction, switchZoomAction, switchLibreAction;
    public int pas = 10;
    private Image fondImg;
    private Monde mondeActuel = null;
    private Element elementActuel = Element.CARRE_D;
    public BufferedImage image, imageTemp;
    private Editeur carteEditeur;

    public CarteImage(Editeur carteEditeur) {
	super(new BorderLayout());
	
	this.carteEditeur = carteEditeur;
	switchGrilleAction = new CarteImageSwitch(CarteImage.switchGrille, this);
	switchFondAction = new CarteImageSwitch(CarteImage.switchFond, this);
	switchZonesAction = new CarteImageSwitch(CarteImage.switchZones, this);
	switchMireAction = new CarteImageSwitch(CarteImage.switchMire, this);
	switchZoomAction = new CarteImageSwitch(CarteImage.switchZoom, this);
	switchLibreAction = new CarteImageSwitch(CarteImage.switchLibre, this);
	
	setPreferredSize(new Dimension(pas * 200, pas * 100));
	addMouseListener(this);
	addMouseMotionListener(this);
	image = new BufferedImage(pas * 200, pas * 100, BufferedImage.TYPE_INT_ARGB);
	imageTemp = new BufferedImage(pas * 200, pas * 100, BufferedImage.TYPE_INT_ARGB);
	redessinner();
    }

    public void switchBool(int flag) {
        switch(flag) {
            case 0 :
                grille = !grille;
                break;
            case 1 :
                fond = !fond;
                break;
            case 2 :
                zones = !zones;
                break;
            case 3 :
                mire = !mire;
                break;
            case 4 :
                pas = 15 - pas;
                image = new BufferedImage(200 * pas, 100 * pas, BufferedImage.TYPE_INT_ARGB);
                setPreferredSize(new Dimension(pas * 200, pas * 100));
                revalidate();
                break;
            case 5 :
                libre = !libre;
        }
        redessinner();
    }

    @Override
    public void paint(Graphics g) {
	g.clearRect(0, 0, this.getWidth(), this.getHeight());
	g.drawImage(image, 0, 0, null);
        if (encours)
            g.drawImage(imageTemp, 0, 0, null);
    }

    public void redessinner() {
        if(carteEditeur.getCartes().getCurrent().getMonde() != mondeActuel) {
        	mondeActuel = carteEditeur.getCartes().getCurrent().getMonde();
            fondImg = getToolkit().getImage(getClass().getResource("/fortedit/mondes/" + mondeActuel.getCode() + ".png"));
            fondImg = new ImageIcon(fondImg).getImage();
        }
        if (!encours)
            dessinner(image.getGraphics());
        else {
            if (libre) {
                Graphics g = imageTemp.getGraphics();
                g.setColor(elementActuel.getCouleur());
                g.fillRect(i1 * pas, j1 * pas, pas, pas);
            } else {
                imageTemp = new BufferedImage(pas * 200, pas * 100, BufferedImage.TYPE_INT_ARGB);
                Graphics g = imageTemp.getGraphics();
                g.setColor(Color.GREEN);
                g.drawRect(Math.min(i0, i1) * pas, Math.min(j0, j1) * pas, (Math.abs(i0 - i1) + 1) * pas, (Math.abs(j0 - j1) + 1) * pas);
            }
        }
	repaint();
    }

    public void dessinner(Graphics g) {
        for (int i = 0; i < 200; i++) {
            for (int j = 0; j < 100; j++) {
                g.setColor(carteEditeur.getCartes().getCurrent().getCases()[i][j].getCouleur());
                g.fillRect(i * pas, j * pas, pas, pas);
            }
        }

        if(grille){
            g.setColor(Color.WHITE);
            for (int i = 1; i < 200; i++)
                g.drawLine(i * pas, 0, i * pas, 100 * pas);
            for (int j = 1; j < 100; j++)
                g.drawLine(0, j * pas, 200 * pas, j * pas);
        }

        if(fond) {
            g.drawImage(fondImg, 0, 0, 200 * pas, 100 * pas, this);
        }

        if(zones) {
            g.setColor(Color.RED);
            for(int i = mondeActuel.getZones()[0]; i < mondeActuel.getZones()[2]; i++)
                for(int j = mondeActuel.getZones()[1]; j < mondeActuel.getZones()[3]; j++)
                    g.drawRect(i * pas, j * pas, pas, pas);
            for(int i = mondeActuel.getZones()[4]; i < mondeActuel.getZones()[6]; i++)
                for(int j = mondeActuel.getZones()[5]; j < mondeActuel.getZones()[7]; j++)
                    g.drawRect(i * pas, j * pas, pas, pas);
        }

        if(mire) {
            g.setColor(Color.RED);
            g.drawLine(100 * pas, 0, 100 * pas, 100 * pas);
            g.drawLine(0, mondeActuel.getMire() * pas / 10, 200 * pas, mondeActuel.getMire() * pas / 10);
        }
    }

    public void mouseClicked(MouseEvent arg0) {}

    public void mouseEntered(MouseEvent arg0) {}

    public void mouseExited(MouseEvent arg0) {}

    public void mousePressed(MouseEvent arg0) {
        if(SwingUtilities.isLeftMouseButton(arg0)) {
        	carteEditeur.getCartes().Ajouter(carteEditeur.getCartes().getCurrent());
            if (libre) {
            	carteEditeur.getCartes().Ajouter(carteEditeur.getCartes().getCurrent());
                carteEditeur.getCartes().getCurrent().getCases()[i1][j1] = elementActuel;
                imageTemp = new BufferedImage(pas * 200, pas * 100, BufferedImage.TYPE_INT_ARGB);
            } else {
                i0 = i1;
                j0 = j1;
                repaint();
            }
            encours = true;
            redessinner();
        } else if(SwingUtilities.isMiddleMouseButton(arg0)) {
            x = arg0.getX() - getVisibleRect().x;
            y = arg0.getY() - getVisibleRect().y;
            temps = new Date().getTime();
        } else if(SwingUtilities.isRightMouseButton(arg0)) {
        	elementActuel = carteEditeur.getCartes().getCurrent().getCases()[arg0.getX() / pas][arg0.getY() / pas];
        }
    }

    public void mouseReleased(MouseEvent arg0) {
        if(SwingUtilities.isLeftMouseButton(arg0)) {
            if (!libre) {
                for (int i = Math.min(i0, i1); i <= Math.max(i0, i1) ; i++) {
                    for (int j = Math.min(j0, j1); j <= Math.max(j0, j1); j++) {
                    	carteEditeur.getCartes().getCurrent().getCases()[i][j] = elementActuel;
                    }
                }
            }
            modif = true;
            encours = false;
            redessinner();
        }
    }

    public void mouseDragged(MouseEvent arg0) {
        i1 = arg0.getX() / pas;
        j1 = arg0.getY() / pas;
        if (i1 >= 200)
            i1 = 199;
        else if (i1 < 0)
            i1 = 0;
        if (j1 >= 100)
            j1 = 99;
        else if (j1 < 0)
            j1 = 0;
        carteEditeur.setEtatCoor("["+(i1+1)+", "+(j1+1)+"]");

        if(SwingUtilities.isLeftMouseButton(arg0)) {
            if (libre) {
            	carteEditeur.getCartes().getCurrent().getCases()[i1][j1] = elementActuel;
            }
            redessinner();
        }

        if(SwingUtilities.isMiddleMouseButton(arg0) && new Date().getTime()-temps >=20) {
            scrollRectToVisible(new Rectangle(getVisibleRect().x+(arg0.getX()-getVisibleRect().x-x)/3*2, getVisibleRect().y+(arg0.getY()-getVisibleRect().y-y)/3*2, getVisibleRect().width, getVisibleRect().height));
            x = arg0.getX() - getVisibleRect().x;
            y = arg0.getY() - getVisibleRect().y;
            temps = new Date().getTime();
        }
    }

    public void mouseMoved(MouseEvent arg0) {
        i1 = arg0.getX() / pas;
        j1 = arg0.getY() / pas;
        carteEditeur.setEtatCoor("["+(i1+1)+", "+(j1+1)+"]");
    }
    
    public void Exporte(File file){
        try {
            if(file!=null) {
                BufferedImage imageExporte = new BufferedImage(200 * pas, 100 * pas, BufferedImage.TYPE_INT_ARGB);
                paint(imageExporte.createGraphics());
                ImageIO.write(imageExporte, "png", file);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

	public AbstractAction getSwitchGrilleAction() {
		return switchGrilleAction;
	}

	public AbstractAction getSwitchFondAction() {
		return switchFondAction;
	}

	public AbstractAction getSwitchZonesAction() {
		return switchZonesAction;
	}

	public AbstractAction getSwitchMireAction() {
		return switchMireAction;
	}

	public AbstractAction getSwitchZoomAction() {
		return switchZoomAction;
	}

	public AbstractAction getSwitchLibreAction() {
		return switchLibreAction;
	}

	public void setElement(Element element) {
		this.elementActuel = element;
	}
}

class CarteImageSwitch extends AbstractAction {
	private static final long serialVersionUID = 1L;
    private int flag;
    private CarteImage image;

    CarteImageSwitch(int flag, CarteImage image) {
        this.flag = flag;
        this.image = image;
    }

    public void actionPerformed(ActionEvent arg0) {
        image.switchBool(flag);
    }
}