package fortedit.editeur;

import java.awt.*;
import java.io.*;

import javax.swing.*;

import fortedit.CarteEditeurTransferHandler;
import fortedit.CarteEditeursetCouleurBouton;
import fortedit.Fenetre;
import fortedit.carte.Cartes;
import fortedit.carte.Element;

public class Editeur extends JPanel {
	private static final long serialVersionUID = 1L;
	private Cartes cartes;
	private CarteImage image;
	private JScrollPane scroll;
	private File fichier, repertoire;
	private JLabel barreEtatFichier, barreEtatCoor;
    
    public Editeur(Fenetre fenetre){
        super(new BorderLayout());
        
        setCartes(new Cartes());
        
        setRepertoire(new File(getClass().getProtectionDomain().getCodeSource().getLocation().getFile()));
        
        JPanel outils = new JPanel();
        
        for (Element element : Element.values()) {
        	outils.add(new CarteEditeursetCouleurBouton(this, element));
        }

        this.add(outils, BorderLayout.NORTH);

        JPanel barreEtat= new JPanel(new BorderLayout());
        barreEtatFichier = new JLabel();
        barreEtatFichier.setEnabled(false);
        barreEtat.add(barreEtatFichier, BorderLayout.WEST);
        barreEtatCoor = new JLabel();
        barreEtatCoor.setEnabled(false);
        barreEtatCoor.setText("[O, O]");
        barreEtat.add(barreEtatCoor, BorderLayout.EAST);
        this.add(barreEtat, BorderLayout.SOUTH);
        
        setImage(new CarteImage(this));
        scroll = new JScrollPane(getImage());
        this.add(scroll, BorderLayout.CENTER);

        this.setTransferHandler(new CarteEditeurTransferHandler(fenetre));
    }

	public void setCartes(Cartes cartes) {
		this.cartes = cartes;
	}

	public Cartes getCartes() {
		return cartes;
	}

	public void setImage(CarteImage image) {
		this.image = image;
	}

	public CarteImage getImage() {
		return image;
	}

	public void setFichier(File fichier) {
		this.fichier = fichier;
	}

	public File getFichier() {
		return fichier;
	}

	public void setRepertoire(File repertoire) {
		this.repertoire = repertoire;
	}

	public File getRepertoire() {
		return repertoire;
	}
	
	public void setEtatFichier(String nom) {
		barreEtatFichier.setText(nom);
	}
	
	public void setEtatCoor(String nom) {
		barreEtatCoor.setText(nom);
	}
}
